--Pop Up quickslots

--Slightly different idea; Player defines a bar as a pop-up bar, then defines which slot causes the pop-up.

--[[To do;
		Unfixable things;
		On the rare chance a player sets all colors to 0.5 the pop button overlay will not be visible. Not worth fixing.
		The indicator can be invisible, as it gets fully hidden under the quickslot. Not a huge problem.
		]]--

--Initialise the pop-up bars		
function initialisepopups()
	for i=1,#Bar do
		if Bar[i].Data.popup~=nil then Bar[i]:PopUp() end
	end
	CloseAllPops()
end

--This defines a button as a pop-up button. argument is the index of the popup button, takes self.Data.popup or 1 as default values if the argument is not given
function NewBar:PopUp(popup)
	local popup=self.Data.popup or 1
	self.Data.popup=popup
	
	for i = 1,self.Data.sx*self.Data.sy do
		self.Quickslot[i]:SetUseOnRightClick(false)
		if i~=popup then
			--This is one of the pop-up quickslots; Register its click events
			self.Quickslot[i].MouseClick = function( sender, args )
				--Copy to the Pop-Up button
					self.Quickslot[popup]:PSetShortcut(self.Quickslot[i]:GetShortcut()) --Get shortcut from target and set to button
					--Hide the all the popup quickslots. BUT! Only if the UI is hidden. Avoids sizing errors, nearly. Awkward players can still mess it up by resizing after locking the UI. Still. All they are really doing is putting the other slots back, which will re-open the bar, but smaller.
					if not(Watcher.flag) then self:PopClose() end
			end
		else
			-- Register to pop up the bar when right clicked
			self.Quickslot[popup].MouseClick = function( sender, args ) 
				if ( args.Button == Turbine.UI.MouseButton.Right ) then
					self:PopToggle()
				end
			end
		end
	end
	if self.PopButton==nil then self:PopBackDropButton() end
end

--Un-define a bar as a pop-up bar
function NewBar:NotPop()
	if self.Data.popup==nil then return end
	if self.Data.sx==1 and self.Data.sy==1 then self:PopOpen() end
	self.Data.popup=nil
	for i = 1,self.Data.sx*self.Data.sy do
			self.Quickslot[i].MouseClick = function( sender, args ) end	--Setting this just to nil did not seem to clear the event properly. So, set to a blank function.
			self.Quickslot[i].MouseClick = nil
		self.Quickslot[i]:SetUseOnRightClick(true)
	end
	self.PopButton:SetVisible(false)
	self.PopButton=nil
end

--Create a backdrop button for the pop-up button.
function NewBar:PopBackDropButton()
	self.PopButton=Turbine.UI.Button()
	if self.Data.popup<1 or self.Data.popup>#self.Quickslot then self.Data.popup=1 end
		local x,y=self.Quickslot[self.Data.popup]:GetPosition()
		self.PopButton :SetPosition			( x-2,y-2)
		self.PopButton :SetSize					( self.Data.size+4,self.Data.size+4 )
		self.PopButton :SetVisible 				( Watcher.flag ) --Show button if HUD is unlocked
		self.PopButton :SetMouseVisible 	(false)
		self.PopButton :SetOpacity				( 1 )
		self.PopButton :SetParent				( self.Window )
		self.PopButton :SetBackColor 		( Turbine.UI.Color(0.5,1-self.Data.color[2],1-self.Data.color[3],1-self.Data.color[4]))
end

--Move the backdrop button to the correct location
function NewBar:MovePopBackDropButton()
local x,y=self.Quickslot[self.Data.popup]:GetPosition()
		self.PopButton :SetPosition			( x-2,y-2)
		self.PopButton :SetSize					( self.Data.size+4,self.Data.size+4 )
		self.PopButton :SetBackColor 		( Turbine.UI.Color(1,1-self.Data.color[2],1-self.Data.color[3],1-self.Data.color[4]))
		--self.Quickslot[self.Data.popup]:SetBackground 	("JackdawPlugins/Bevy2/Skins/Frame.tga") A little experiment in adding a backdrop to the pop-up button. Not successful - would need more work than it is worth.
self:PopUp()
end

--Close a bar
function NewBar:PopClose()
	--First, prevent the user from closing a PopUp if the option window is showing...
	if Option~=nil then return end
	if Opt.Window~=nil then
		if Opt.Window:IsVisible() then return end
	end
	self.Popped=false
	--Store the size of the bar
		self.Data.Pop={}
		--Preserve the size data
		self.Data.Pop.sx=self.Data.sx
		self.Data.Pop.sy=self.Data.sy
		--Preserve the position data
		self.Data.Pop.x,self.Data.Pop.y=self:GetPosition()
		
	--Move the bar
		local x,y=self.Quickslot[self.Data.popup]:GetPosition()
		local adjust=math.floor(self.Data.size/10)-self.Data.pad
		x=x+self.Data.Pop.x+adjust
		y=y+self.Data.Pop.y+adjust
		
	--Set the size to be a 1x1 bar
		self:SetSize(1,1)
	
	--Move the correct quickslot in!
		self.Quickslot[1]:SetVisible(false)
		self.Quickslot[self.Data.popup]:SetVisible(true)
		local adjust=math.floor(self.Data.size/10)
		self.Quickslot[self.Data.popup]:SetStretchMode(1)
		self.Quickslot[self.Data.popup]:SetSize(self.Data.size,self.Data.size)
		self.Quickslot[self.Data.popup]:SetPosition(self.Data.pad-adjust,self.Data.pad-adjust)
		
		self:SetPosition(x,y)
		
		self.PopButton :SetVisible 			( Watcher.flag ) --Show button if HUD is unlocked
		if Modules.skin then self:Skin() end
end

--Open a bar
function NewBar:PopOpen()
	if self.Data.Pop==nil then return end
	self.Popped=true
	self.Data.sx=self.Data.Pop.sx
	self.Data.sy=self.Data.Pop.sy
	--Restore normal size and position
	self:SetSize(self.Data.sx,self.Data.sy)
	self:SetPosition(self.Data.Pop.x,self.Data.Pop.y)

	self.PopButton :SetVisible 			( Watcher.flag ) --Show button if HUD is unlocked
	if Modules.skin then self:Skin() end
	end

--Toggle a bar	
function NewBar:PopToggle()
	if self.Data.sx==1 and self.Data.sy==1 then self:PopOpen() else self:PopClose() end
end

--Function to be called before saving, or when the UI is unlocked
function OpenAllPops()
	for i=1,#Bar do
		if Bar[i].Data.popup~=nil then if  Bar[i].Data.sx==1 and  Bar[i].Data.sy==1 then Bar[i]:PopOpen() end end
	end
end

--Function to be called after loading, or when the UI is Locked
function CloseAllPops()
	for i=1,#Bar do
		if Bar[i].Data.popup~=nil then if  Bar[i].Data.sx~=1 or  Bar[i].Data.sy~=1 then Bar[i]:PopClose() end end
	end
end

initialisepopups()

--Option Box functions
table.insert(Opt.Module,
	function()
		Opt.PopUp=CollapseBox("Pop Up Bar Options","f",1,true)
		Opt.ListBox:AddItem(Opt.PopUp)
		Opt.popup=Opt.CheckBox("Pop Up Bar?",function(k,i) if k then Bar[i]:PopUp() else Bar[i]:NotPop() end end )
		Opt.PopUp.Content:AddItem(Opt.popup)
		Opt.popslider=Opt.Slider("Slot",1,10, function(k,i) 
			if k>(Bar[i].Data.sx*Bar[i].Data.sy) then k=Bar[i].Data.sx*Bar[i].Data.sy end
			Bar[i].Data.popup=k 
			Bar[i]:MovePopBackDropButton() 
			Opt.popslider:SetMax(Opt.val.sx*Opt.val.sy)
		end)
		Opt.PopUp.Content:AddItem(Opt.popslider)
		table.insert(Opt.source,"popup")

		end)
		
table.insert(Opt.Updaters, 
	function()
	if Opt.popslider~=nil then 
		Opt.popslider:SetVal(Opt.val.popup) 
		
		if Opt.Check.popup then 
			--Not all the Bars have the same value for this set the back to grey
			Opt.popslider:SetBackColor(Turbine.UI.Color(1,0.3,0.3,0.3))
		else
			--All the same? Transparent back
			Opt.popslider:SetBackColor(nil)
		end	
		
	end
end)
